Uri? extractUri(json) {
  return JsonUri.fromJson(json);
}

class JsonUri implements Uri {
  final Uri _delegate;

  const JsonUri(this._delegate);

  dynamic toJson() {
    return "$this";
  }

  static Uri? fromJson(dynamic) {
    if (dynamic == null) return null;
    if (dynamic is Uri) {
      return JsonUri(dynamic);
    } else {
      final parsed = Uri.tryParse(dynamic.toString());
      if (parsed == null) return null;
      return JsonUri(parsed);
    }
  }

  @override
  String get authority => _delegate.authority;

  @override
  UriData? get data => _delegate.data;

  @override
  String get fragment => _delegate.fragment;

  @override
  bool get hasAbsolutePath => _delegate.hasAbsolutePath;

  @override
  bool get hasAuthority => _delegate.hasAuthority;

  @override
  bool get hasEmptyPath => _delegate.hasEmptyPath;

  @override
  bool get hasFragment => _delegate.hasFragment;

  @override
  bool get hasPort => _delegate.hasPort;

  @override
  bool get hasQuery => _delegate.hasQuery;

  @override
  String get host => _delegate.host;

  @override
  bool get isAbsolute => _delegate.isAbsolute;

  @override
  bool isScheme(String scheme) => _delegate.isScheme(scheme);

  @override
  Uri normalizePath() => _delegate.normalizePath();

  @override
  String get origin => _delegate.origin;

  @override
  String get path => _delegate.path;

  @override
  List<String> get pathSegments => _delegate.pathSegments;

  @override
  int get port => _delegate.port;

  @override
  String get query => _delegate.query;

  @override
  Map<String, String> get queryParameters => _delegate.queryParameters;

  @override
  Map<String, List<String>> get queryParametersAll =>
      _delegate.queryParametersAll;

  @override
  Uri removeFragment() {
    return _delegate.removeFragment();
  }

  @override
  Uri replace(
      {String? scheme,
      String? userInfo,
      String? host,
      int? port,
      String? path,
      Iterable<String>? pathSegments,
      String? query,
      Map<String, dynamic /*String|Iterable<String>*/ >? queryParameters,
      String? fragment}) {
    return _delegate.replace(
      scheme: scheme ?? this.scheme,
      userInfo: userInfo ?? this.userInfo,
      host: host ?? this.host,
      port: port ?? this.port,
      path: path ?? this.path,
      pathSegments: pathSegments ?? this.pathSegments,
      query: query ?? this.query,
      queryParameters: queryParameters ?? this.queryParameters,
      fragment: fragment ?? this.fragment,
    );
  }

  @override
  Uri resolve(String scheme) => _delegate.resolve(scheme);

  @override
  Uri resolveUri(Uri uri) => _delegate.resolveUri(uri);

  @override
  String get scheme => _delegate.scheme;

  @override
  String toFilePath({bool? windows}) {
    return _delegate.toFilePath(windows: windows);
  }

  @override
  String get userInfo => _delegate.userInfo;

  @override
  bool get hasScheme => _delegate.hasScheme;

  @override
  String toString() {
    return _delegate.toString();
  }

  @override
  bool operator ==(Object other) {
    return _delegate == other;
  }

  @override
  int get hashCode {
    return _delegate.hashCode;
  }
}
