import 'package:flutter/cupertino.dart';
import 'package:sunny_lifecycle/routing/route_history.dart';

typedef RoutingSystemFactory = RoutingSystem Function();

class RoutingSystem<T extends Object> {
  bool _isDisposed = false;

  final RouterDelegate<T> delegate;
  final RouteInformationProvider? provider;
  final RouteInformationParser<T> parser;
  final Inspector<RoutingSystem>? _dispose;
  final BackButtonDispatcher? backButtonDispatcher;

  RoutingSystem(
      {required this.delegate, this.provider, this.backButtonDispatcher, required this.parser, Inspector<RoutingSystem>? dispose})
      : _dispose = dispose;

  void dispose() {
    if (!_isDisposed) {
      _isDisposed = true;
      this._dispose?.call(this);
    }
  }
}
