import 'icon_shared.dart';

/// Generates a sunny icon snippet based on icon names in the main google doc spreadsheet
///
String generateSunnyIconSnippet(Iterable<IconDefinition> icons) {
  // A hack, but this will output a snippet that can be copied into the
  // sunny_named_icon file
  return icons
      .map((entry) {
        try {
          final snake = entry.iconName;
          final camel = entry.iconVariableName;
          return """$camel = icon("$snake", Line8Icons.${camel}Outline, Line8Icons.${camel}Solid)""";
        } catch (e) {
          /// do nothing
          return null;
        }
      })
      .where((_) => _ != null)
      .join(",\n");
}

main() async {
  final processed = [...await readIconDefinitions()];
  print(generateSunnyIconSnippet(processed));
}
